public final class atom{
    vector pos,             // current position
           force,           // force accumulator
           vel;             // velocity
     double radius,         // contact radius
           mass,            // atom mass >= 1
           imass;           // inverse of mass precalc
    boolean rested;         // if moving or not

    //spring
    static int maxLink = 6;
    int linkedTo[] = new int[maxLink];
    int linkQty = 0;
    double lenght[] = new double[maxLink],
           rigidity[] = new double[maxLink],
           breaklimit[] = new double[maxLink];
    
    public atom(atom a)
    {
        pos = a.pos;
        vel = a.vel;
        force = a.force;
        radius = a.radius;
        mass = a.mass;
        imass = a.imass;
        rested = a.rested;
        //spr
        linkQty = a.linkQty;
        linkedTo = a.linkedTo;
        lenght = a.lenght;
        rigidity = a.rigidity;
        breaklimit = a.breaklimit;
    }
    
    public atom(int x, int y)
    {
        pos = new vector((double)x, (double)y);
        radius = 2.0d;
        mass = 10.0d;
        imass = 1.0d/mass;
        vel = new vector();
        force = new vector();
        rested = false;
        //spr
        linkQty = 0;
    }
    
    public atom(int x, int y, double numass, double nuradius)
    {
        pos = new vector((double)x, (double)y);
        radius = nuradius;
        mass = numass;
        imass = 1.0d/mass;
        vel = new vector(0,0);
        force = new vector();
        rested = false;
        //spr
        linkQty = 0;
    }

};
